# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from extensions import extension_pb2 as extensions_dot_extension__pb2


class ExtensionStub(object):
    """Extension - API расширения
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Install = channel.unary_unary(
                '/extensions.Extension/Install',
                request_serializer=extensions_dot_extension__pb2.InstallRequest.SerializeToString,
                response_deserializer=extensions_dot_extension__pb2.InstallResponse.FromString,
                )
        self.Check = channel.unary_unary(
                '/extensions.Extension/Check',
                request_serializer=extensions_dot_extension__pb2.CheckRequest.SerializeToString,
                response_deserializer=extensions_dot_extension__pb2.CheckResponse.FromString,
                )
        self.Update = channel.unary_unary(
                '/extensions.Extension/Update',
                request_serializer=extensions_dot_extension__pb2.UpdateRequest.SerializeToString,
                response_deserializer=extensions_dot_extension__pb2.UpdateResponse.FromString,
                )
        self.Uninstall = channel.unary_unary(
                '/extensions.Extension/Uninstall',
                request_serializer=extensions_dot_extension__pb2.UninstallRequest.SerializeToString,
                response_deserializer=extensions_dot_extension__pb2.UninstallResponse.FromString,
                )
        self.Action = channel.unary_unary(
                '/extensions.Extension/Action',
                request_serializer=extensions_dot_extension__pb2.ActionRequest.SerializeToString,
                response_deserializer=extensions_dot_extension__pb2.ActionResponse.FromString,
                )


class ExtensionServicer(object):
    """Extension - API расширения
    """

    def Install(self, request, context):
        """Для установки расширения выполняется запрос к сервису с указанием расширений которые должны быть установлены. Если
        расширение уже установлено процесс возвращает ошибку.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Check(self, request, context):
        """Можно запросить проверку статуса установки для расширения. При этом расширение проверяет наличие необходимых данных в
        пространстве или наличие новой версии расширения и сообщает об этом. Никаких действий с данными пространства не
        производится.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Update(self, request, context):
        """Сервис выполняет необходимые действия с данными и миграции для соответствия нужной версии расширения.
        Если расширение не установлено процесс обновления возвращает ошибку.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Uninstall(self, request, context):
        """Удаление расширения из пространства.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Action(self, request, context):
        """Пользовательские Действия (Actions)

        Пользовательские действия позволяют расширить функционал пользовательского интерфейса путем
        добавления в интерфейс элементов взаимодействуя с которыми пользователь может вызывать реакцию на
        сервере или переход в интерфейсе.

        Пользовательские действия добавляются при установке расширений в системную коллекции `System/Actions`.
        Коллекция создается автоматически менеджером расширений. При установке так же отображается меню `Действия`
        доступное для всех пользователей.

        Примеры пользовательских действий:
        - "Собрать сайт" - добавляется Perxis.Web для сборки сайта, доступна пользователю через меню,
        параметры space_id, env_id. При вызове выполняется запрос на сервер ProcessAction.
        - "Посмотреть задачи" - добавляется Tasks для перехода на коллекцию задач. Отображается в меню,
        параметры space_id, env_id.

        Приложения так же могут использовать действия для вызова обработки в других приложениях при
        необходимости.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_ExtensionServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'Install': grpc.unary_unary_rpc_method_handler(
                    servicer.Install,
                    request_deserializer=extensions_dot_extension__pb2.InstallRequest.FromString,
                    response_serializer=extensions_dot_extension__pb2.InstallResponse.SerializeToString,
            ),
            'Check': grpc.unary_unary_rpc_method_handler(
                    servicer.Check,
                    request_deserializer=extensions_dot_extension__pb2.CheckRequest.FromString,
                    response_serializer=extensions_dot_extension__pb2.CheckResponse.SerializeToString,
            ),
            'Update': grpc.unary_unary_rpc_method_handler(
                    servicer.Update,
                    request_deserializer=extensions_dot_extension__pb2.UpdateRequest.FromString,
                    response_serializer=extensions_dot_extension__pb2.UpdateResponse.SerializeToString,
            ),
            'Uninstall': grpc.unary_unary_rpc_method_handler(
                    servicer.Uninstall,
                    request_deserializer=extensions_dot_extension__pb2.UninstallRequest.FromString,
                    response_serializer=extensions_dot_extension__pb2.UninstallResponse.SerializeToString,
            ),
            'Action': grpc.unary_unary_rpc_method_handler(
                    servicer.Action,
                    request_deserializer=extensions_dot_extension__pb2.ActionRequest.FromString,
                    response_serializer=extensions_dot_extension__pb2.ActionResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'extensions.Extension', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class Extension(object):
    """Extension - API расширения
    """

    @staticmethod
    def Install(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/extensions.Extension/Install',
            extensions_dot_extension__pb2.InstallRequest.SerializeToString,
            extensions_dot_extension__pb2.InstallResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Check(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/extensions.Extension/Check',
            extensions_dot_extension__pb2.CheckRequest.SerializeToString,
            extensions_dot_extension__pb2.CheckResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Update(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/extensions.Extension/Update',
            extensions_dot_extension__pb2.UpdateRequest.SerializeToString,
            extensions_dot_extension__pb2.UpdateResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Uninstall(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/extensions.Extension/Uninstall',
            extensions_dot_extension__pb2.UninstallRequest.SerializeToString,
            extensions_dot_extension__pb2.UninstallResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Action(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/extensions.Extension/Action',
            extensions_dot_extension__pb2.ActionRequest.SerializeToString,
            extensions_dot_extension__pb2.ActionResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
